Subject: Re: Invalid DLL on NT.(was Re: Console GUI, bad dll executables)
From: [email-masked] (William Greathouse)

16 Jul 1997 13:18:22 -0700
Approved: [email-masked]
Distribution: cygnus
Message-ID: <[email-masked]>
References: <[email-masked]>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
>Received: from iago by mailserv.smva.com (AIX 3.2/UCB 5.64/4.03)
          id AA13143; Wed, 16 Jul 1997 09: 26:41 -0400
X-Mailer: Mozilla 4.0b5 [en] (Win95; I)
Original-To: Eric Britten <[email-masked]>
Original-Cc: gnu-win32 <[email-masked]>
X-Priority: 3 (Normal)
Original-Sender: [email-masked]

Eric Britten wrote:
> 
> When I try to run a program I wrote on NT I get the following error.
> 
> The application or DLL c:\temp\gnugui.dll is not a valid Windows NT
> image.
> 
> My program included an exe and its dll.  I produced these two
> executables
> with b18.  However they will run on Windows 95.
> 
> The executables can be found at
> http://pages.prodigy.com/britten/gnugui/conguib3a.zip
> 
> Using quickview I found that the name of a section dealing with stabs
> had
> some invalid characters.  The section was
> .stabstri[B]
> where i is i with the umlaut and [B] was just an undefinable character
> that looks like a box.
> 
> I have studied PE images before and seem to remember that section
> names
> can only be 8 characters long. This section is 10 characters long.
> Could
> this be the problem?  And if so why doesn't Windows 95 flag this as an
> error.  If this is the problem I will build the dll without debug info
> and
> post it to my website above by wednesday June 16.
> 
> This could be a bug in ld.
> 
> Thanks for any help.

Eric,

The entry is fine... The problem is the program that you are using to
dump the entry expects a '\0' terminated string.  If the section name is
precisely 8 characters in length, it is not a C terminated string.  The
two extra characters are actually part of the section information, the
actual section name is ".stabstr" (8 characters).

Are you linking your DLL with fixup.o?

Bill
-- 
William Greathouse                | [email-masked]  Email
SMV America, Engineering          | [email-masked]        Email
8380 Darrow Road                  | (216) 425-1340 x4006  Voice
Twinsburg, OH  44087              | (216) 405-7684        FAX

-
For help on using this list (especially unsubscribing), send a message to
"[email-masked]" with one line of text: "help".